export type DeviceManagerPromiseSuccessType = {
    s: string;
    i: number;
};
export type DeviceIdParams = {
    deviceId: string;
};
export type DeviceCredentialParams = {
    deviceId: string;
    deviceLogin: string;
    devicePassword: string;
};
export declare function loginDevice(params: DeviceCredentialParams): Promise<DeviceManagerPromiseSuccessType>;
export declare function loginDeviceWithCredential(params: DeviceCredentialParams): Promise<DeviceManagerPromiseSuccessType>;
export declare function logoutDevice(params: DeviceIdParams): Promise<true>;
export declare function getChannelInfo(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export declare function getChannelCount(params: DeviceIdParams): Promise<number>;
export type LocalLoginInfoParams = DeviceCredentialParams & {
    token: string;
};
export type ModifyDevicePasswordParams = DeviceCredentialParams & {
    deviceNewPassword: string;
};
export declare function modifyDevicePassword(params: ModifyDevicePasswordParams): Promise<DeviceManagerPromiseSuccessType>;
export type ModifyDeviceNameParams = DeviceIdParams & {
    deviceName: string;
};
export declare function modifyDeviceName(params: ModifyDevicePasswordParams): Promise<DeviceManagerPromiseSuccessType>;
export type DevicePTZControlParams = {
    deviceId: string;
    command: number;
    bStop: boolean;
    deviceChannel: number;
};
export declare function devicePTZcontrol(params: DevicePTZControlParams): Promise<boolean>;
export declare function resetDeviceConfig(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export declare function rebootDevice(params: DeviceIdParams): Promise<DeviceManagerPromiseSuccessType>;
export type CaptureFromDeviceAndSaveToDeviceParams = {
    deviceId: string;
    deviceChannel: number;
};
export declare function captureFromDeviceAndSaveToDevice(params: CaptureFromDeviceAndSaveToDeviceParams): Promise<DeviceManagerPromiseSuccessType>;
//# sourceMappingURL=manager.d.ts.map